/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Account, Address, Codec, Decoder, EncodedAccount, Encoder, FetchAccountConfig, FetchAccountsConfig, MaybeAccount, MaybeEncodedAccount, Option, OptionOrNullable, ReadonlyUint8Array, fetchEncodedAccount, fetchEncodedAccounts } from '@solana/web3.js';
import { OrderStateSeeds } from '../pdas';
import { OrderType, OrderTypeArgs } from '../types';
export type OrderState = {
    discriminator: ReadonlyUint8Array;
    version: number;
    bump: Array<number>;
    orderId: ReadonlyUint8Array;
    orderType: OrderType;
    nonce: number;
    maker: Address;
    price: bigint;
    currency: Option<Address>;
    aprBps: number;
    durationSec: number;
    whitelist: Address;
    makerBroker: Option<Address>;
    margin: Option<Address>;
    expiry: bigint;
    createdAt: bigint;
    updatedAt: bigint;
    nftsHeld: number;
    vaultBalance: bigint;
    lockedAt: bigint;
    lockedUntil: bigint;
    taker: Option<Address>;
    collateralReturned: boolean;
    lastExercisedAt: bigint;
    exerciseCount: number;
    accumulatedProfit: bigint;
    takerWithdrawnNfts: number;
    takerWithdrawnFunds: bigint;
    earlyClose: boolean;
    reserved0: Array<number>;
    reserved1: ReadonlyUint8Array;
    reserved2: ReadonlyUint8Array;
};
export type OrderStateArgs = {
    version: number;
    bump: Array<number>;
    orderId: ReadonlyUint8Array;
    orderType: OrderTypeArgs;
    nonce: number;
    maker: Address;
    price: number | bigint;
    currency: OptionOrNullable<Address>;
    aprBps: number;
    durationSec: number;
    whitelist: Address;
    makerBroker: OptionOrNullable<Address>;
    margin: OptionOrNullable<Address>;
    expiry: number | bigint;
    createdAt: number | bigint;
    updatedAt: number | bigint;
    nftsHeld: number;
    vaultBalance: number | bigint;
    lockedAt: number | bigint;
    lockedUntil: number | bigint;
    taker: OptionOrNullable<Address>;
    collateralReturned: boolean;
    lastExercisedAt: number | bigint;
    exerciseCount: number;
    accumulatedProfit: number | bigint;
    takerWithdrawnNfts: number;
    takerWithdrawnFunds: number | bigint;
    earlyClose: boolean;
    reserved0: Array<number>;
    reserved1: ReadonlyUint8Array;
    reserved2: ReadonlyUint8Array;
};
export declare function getOrderStateEncoder(): Encoder<OrderStateArgs>;
export declare function getOrderStateDecoder(): Decoder<OrderState>;
export declare function getOrderStateCodec(): Codec<OrderStateArgs, OrderState>;
export declare function decodeOrderState<TAddress extends string = string>(encodedAccount: EncodedAccount<TAddress>): Account<OrderState, TAddress>;
export declare function decodeOrderState<TAddress extends string = string>(encodedAccount: MaybeEncodedAccount<TAddress>): MaybeAccount<OrderState, TAddress>;
export declare function fetchOrderState<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<Account<OrderState, TAddress>>;
export declare function fetchMaybeOrderState<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<MaybeAccount<OrderState, TAddress>>;
export declare function fetchAllOrderState(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<Account<OrderState>[]>;
export declare function fetchAllMaybeOrderState(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<MaybeAccount<OrderState>[]>;
export declare function fetchOrderStateFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: OrderStateSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<Account<OrderState>>;
export declare function fetchMaybeOrderStateFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: OrderStateSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<MaybeAccount<OrderState>>;
//# sourceMappingURL=orderState.d.ts.map