/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_PRICE_LOCK_PROGRAM_ADDRESS } from '../programs';
import { TMetadataArgs, TMetadataArgsArgs } from '../types';
export type SellCompressedInstruction<TProgram extends string = typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountTaker extends string | IAccountMeta<string> = string, TAccountOrderState extends string | IAccountMeta<string> = string, TAccountOrderVault extends string | IAccountMeta<string> = string, TAccountMaker extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountSystem extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountMarginAccount extends string | IAccountMeta<string> = string, TAccountTlockProgram extends string | IAccountMeta<string> = 'TLoCKic2wGJm7VhZKumih4Lc35fUhYqVMgA4j389Buk', TAccountTreeAuthority extends string | IAccountMeta<string> = string, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = 'noopb9bkMVfRPU8AsbpTUg8AQkHtKwMYZiFUjNRtMmV', TAccountCompressionProgram extends string | IAccountMeta<string> = 'cmtDvXumGCrqC1Age74AVPhSRVXJMd8PJS91L8KbNCK', TAccountBubblegumProgram extends string | IAccountMeta<string> = 'BGUMAp9Gq7iTEuizy4pqaxsTyUCBK68MDfK752saRPUY', TAccountOrderNftReceipt extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountFeeVault extends string ? WritableAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountTaker extends string ? WritableSignerAccount<TAccountTaker> & IAccountSignerMeta<TAccountTaker> : TAccountTaker,
    TAccountOrderState extends string ? WritableAccount<TAccountOrderState> : TAccountOrderState,
    TAccountOrderVault extends string ? WritableAccount<TAccountOrderVault> : TAccountOrderVault,
    TAccountMaker extends string ? WritableAccount<TAccountMaker> : TAccountMaker,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountSystem extends string ? ReadonlyAccount<TAccountSystem> : TAccountSystem,
    TAccountMarginAccount extends string ? ReadonlyAccount<TAccountMarginAccount> : TAccountMarginAccount,
    TAccountTlockProgram extends string ? ReadonlyAccount<TAccountTlockProgram> : TAccountTlockProgram,
    TAccountTreeAuthority extends string ? ReadonlyAccount<TAccountTreeAuthority> : TAccountTreeAuthority,
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    TAccountCompressionProgram extends string ? ReadonlyAccount<TAccountCompressionProgram> : TAccountCompressionProgram,
    TAccountBubblegumProgram extends string ? ReadonlyAccount<TAccountBubblegumProgram> : TAccountBubblegumProgram,
    TAccountOrderNftReceipt extends string ? WritableAccount<TAccountOrderNftReceipt> : TAccountOrderNftReceipt,
    ...TRemainingAccounts
]>;
export type SellCompressedInstructionData = {
    discriminator: ReadonlyUint8Array;
    minAmount: bigint;
    optionalRoyaltyPct: Option<number>;
    root: ReadonlyUint8Array;
    nonce: bigint;
    index: number;
    metaArgs: TMetadataArgs;
};
export type SellCompressedInstructionDataArgs = {
    minAmount: number | bigint;
    optionalRoyaltyPct?: OptionOrNullable<number>;
    root: ReadonlyUint8Array;
    nonce: number | bigint;
    index: number;
    metaArgs: TMetadataArgsArgs;
};
export declare function getSellCompressedInstructionDataEncoder(): Encoder<SellCompressedInstructionDataArgs>;
export declare function getSellCompressedInstructionDataDecoder(): Decoder<SellCompressedInstructionData>;
export declare function getSellCompressedInstructionDataCodec(): Codec<SellCompressedInstructionDataArgs, SellCompressedInstructionData>;
export type SellCompressedInstructionExtraArgs = {
    /** creators, structured like [ [creator_pubkey_1,creator_shares_1], ..., [creator_pubkey_n, creator_shares_n] ] */
    creators?: Array<readonly [Address, number]>;
    /** proof path, can be shortened if canopyDepth of merkle tree is also specified */
    proof?: Array<Address>;
    /** canopy depth of merkle tree, reduces proofPath length if specified */
    canopyDepth?: number;
};
export type SellCompressedAsyncInput<TAccountFeeVault extends string = string, TAccountTaker extends string = string, TAccountOrderState extends string = string, TAccountOrderVault extends string = string, TAccountMaker extends string = string, TAccountWhitelist extends string = string, TAccountSystem extends string = string, TAccountMarginAccount extends string = string, TAccountTlockProgram extends string = string, TAccountTreeAuthority extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountOrderNftReceipt extends string = string> = {
    feeVault: Address<TAccountFeeVault>;
    taker: TransactionSigner<TAccountTaker>;
    orderState: Address<TAccountOrderState>;
    orderVault?: Address<TAccountOrderVault>;
    maker: Address<TAccountMaker>;
    whitelist: Address<TAccountWhitelist>;
    system?: Address<TAccountSystem>;
    marginAccount?: Address<TAccountMarginAccount>;
    tlockProgram?: Address<TAccountTlockProgram>;
    treeAuthority?: Address<TAccountTreeAuthority>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    orderNftReceipt: Address<TAccountOrderNftReceipt>;
    minAmount: SellCompressedInstructionDataArgs['minAmount'];
    optionalRoyaltyPct?: SellCompressedInstructionDataArgs['optionalRoyaltyPct'];
    root: SellCompressedInstructionDataArgs['root'];
    nonce: SellCompressedInstructionDataArgs['nonce'];
    index: SellCompressedInstructionDataArgs['index'];
    metaArgs: SellCompressedInstructionDataArgs['metaArgs'];
    creators?: SellCompressedInstructionExtraArgs['creators'];
    proof?: SellCompressedInstructionExtraArgs['proof'];
    canopyDepth?: SellCompressedInstructionExtraArgs['canopyDepth'];
};
export declare function getSellCompressedInstructionAsync<TAccountFeeVault extends string, TAccountTaker extends string, TAccountOrderState extends string, TAccountOrderVault extends string, TAccountMaker extends string, TAccountWhitelist extends string, TAccountSystem extends string, TAccountMarginAccount extends string, TAccountTlockProgram extends string, TAccountTreeAuthority extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountBubblegumProgram extends string, TAccountOrderNftReceipt extends string>(input: SellCompressedAsyncInput<TAccountFeeVault, TAccountTaker, TAccountOrderState, TAccountOrderVault, TAccountMaker, TAccountWhitelist, TAccountSystem, TAccountMarginAccount, TAccountTlockProgram, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountBubblegumProgram, TAccountOrderNftReceipt>): Promise<SellCompressedInstruction<typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountFeeVault, TAccountTaker, TAccountOrderState, TAccountOrderVault, TAccountMaker, TAccountWhitelist, TAccountSystem, TAccountMarginAccount, TAccountTlockProgram, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountBubblegumProgram, TAccountOrderNftReceipt>>;
export type SellCompressedInput<TAccountFeeVault extends string = string, TAccountTaker extends string = string, TAccountOrderState extends string = string, TAccountOrderVault extends string = string, TAccountMaker extends string = string, TAccountWhitelist extends string = string, TAccountSystem extends string = string, TAccountMarginAccount extends string = string, TAccountTlockProgram extends string = string, TAccountTreeAuthority extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountOrderNftReceipt extends string = string> = {
    feeVault: Address<TAccountFeeVault>;
    taker: TransactionSigner<TAccountTaker>;
    orderState: Address<TAccountOrderState>;
    orderVault: Address<TAccountOrderVault>;
    maker: Address<TAccountMaker>;
    whitelist: Address<TAccountWhitelist>;
    system?: Address<TAccountSystem>;
    marginAccount?: Address<TAccountMarginAccount>;
    tlockProgram?: Address<TAccountTlockProgram>;
    treeAuthority: Address<TAccountTreeAuthority>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    orderNftReceipt: Address<TAccountOrderNftReceipt>;
    minAmount: SellCompressedInstructionDataArgs['minAmount'];
    optionalRoyaltyPct?: SellCompressedInstructionDataArgs['optionalRoyaltyPct'];
    root: SellCompressedInstructionDataArgs['root'];
    nonce: SellCompressedInstructionDataArgs['nonce'];
    index: SellCompressedInstructionDataArgs['index'];
    metaArgs: SellCompressedInstructionDataArgs['metaArgs'];
    creators?: SellCompressedInstructionExtraArgs['creators'];
    proof?: SellCompressedInstructionExtraArgs['proof'];
    canopyDepth?: SellCompressedInstructionExtraArgs['canopyDepth'];
};
export declare function getSellCompressedInstruction<TAccountFeeVault extends string, TAccountTaker extends string, TAccountOrderState extends string, TAccountOrderVault extends string, TAccountMaker extends string, TAccountWhitelist extends string, TAccountSystem extends string, TAccountMarginAccount extends string, TAccountTlockProgram extends string, TAccountTreeAuthority extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountBubblegumProgram extends string, TAccountOrderNftReceipt extends string>(input: SellCompressedInput<TAccountFeeVault, TAccountTaker, TAccountOrderState, TAccountOrderVault, TAccountMaker, TAccountWhitelist, TAccountSystem, TAccountMarginAccount, TAccountTlockProgram, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountBubblegumProgram, TAccountOrderNftReceipt>): SellCompressedInstruction<typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountFeeVault, TAccountTaker, TAccountOrderState, TAccountOrderVault, TAccountMaker, TAccountWhitelist, TAccountSystem, TAccountMarginAccount, TAccountTlockProgram, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountBubblegumProgram, TAccountOrderNftReceipt>;
export type ParsedSellCompressedInstruction<TProgram extends string = typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        feeVault: TAccountMetas[0];
        taker: TAccountMetas[1];
        orderState: TAccountMetas[2];
        orderVault: TAccountMetas[3];
        maker: TAccountMetas[4];
        whitelist: TAccountMetas[5];
        system: TAccountMetas[6];
        marginAccount?: TAccountMetas[7] | undefined;
        tlockProgram: TAccountMetas[8];
        treeAuthority: TAccountMetas[9];
        merkleTree: TAccountMetas[10];
        logWrapper: TAccountMetas[11];
        compressionProgram: TAccountMetas[12];
        bubblegumProgram: TAccountMetas[13];
        orderNftReceipt: TAccountMetas[14];
    };
    data: SellCompressedInstructionData;
};
export declare function parseSellCompressedInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedSellCompressedInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=sellCompressed.d.ts.map