/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_PRICE_LOCK_PROGRAM_ADDRESS } from '../programs';
import { TMetadataArgs, TMetadataArgsArgs } from '../types';
export type WithdrawCompressedInstruction<TProgram extends string = typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountMaker extends string | IAccountMeta<string> = string, TAccountOrderState extends string | IAccountMeta<string> = string, TAccountOrderVault extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountSystem extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountTlockProgram extends string | IAccountMeta<string> = 'TLoCKic2wGJm7VhZKumih4Lc35fUhYqVMgA4j389Buk', TAccountTreeAuthority extends string | IAccountMeta<string> = string, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = 'noopb9bkMVfRPU8AsbpTUg8AQkHtKwMYZiFUjNRtMmV', TAccountCompressionProgram extends string | IAccountMeta<string> = 'cmtDvXumGCrqC1Age74AVPhSRVXJMd8PJS91L8KbNCK', TAccountBubblegumProgram extends string | IAccountMeta<string> = 'BGUMAp9Gq7iTEuizy4pqaxsTyUCBK68MDfK752saRPUY', TAccountOrderNftReceipt extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMaker extends string ? WritableSignerAccount<TAccountMaker> & IAccountSignerMeta<TAccountMaker> : TAccountMaker,
    TAccountOrderState extends string ? WritableAccount<TAccountOrderState> : TAccountOrderState,
    TAccountOrderVault extends string ? WritableAccount<TAccountOrderVault> : TAccountOrderVault,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountSystem extends string ? ReadonlyAccount<TAccountSystem> : TAccountSystem,
    TAccountTlockProgram extends string ? ReadonlyAccount<TAccountTlockProgram> : TAccountTlockProgram,
    TAccountTreeAuthority extends string ? ReadonlyAccount<TAccountTreeAuthority> : TAccountTreeAuthority,
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    TAccountCompressionProgram extends string ? ReadonlyAccount<TAccountCompressionProgram> : TAccountCompressionProgram,
    TAccountBubblegumProgram extends string ? ReadonlyAccount<TAccountBubblegumProgram> : TAccountBubblegumProgram,
    TAccountOrderNftReceipt extends string ? WritableAccount<TAccountOrderNftReceipt> : TAccountOrderNftReceipt,
    ...TRemainingAccounts
]>;
export type WithdrawCompressedInstructionData = {
    discriminator: ReadonlyUint8Array;
    root: ReadonlyUint8Array;
    nonce: bigint;
    index: number;
    metaArgs: TMetadataArgs;
};
export type WithdrawCompressedInstructionDataArgs = {
    root: ReadonlyUint8Array;
    nonce: number | bigint;
    index: number;
    metaArgs: TMetadataArgsArgs;
};
export declare function getWithdrawCompressedInstructionDataEncoder(): Encoder<WithdrawCompressedInstructionDataArgs>;
export declare function getWithdrawCompressedInstructionDataDecoder(): Decoder<WithdrawCompressedInstructionData>;
export declare function getWithdrawCompressedInstructionDataCodec(): Codec<WithdrawCompressedInstructionDataArgs, WithdrawCompressedInstructionData>;
export type WithdrawCompressedInstructionExtraArgs = {
    /** creators, structured like [ [creator_pubkey_1,creator_shares_1], ..., [creator_pubkey_n, creator_shares_n] ] */
    creators?: Array<readonly [Address, number]>;
    /** proof path, can be shortened if canopyDepth of merkle tree is also specified */
    proof?: Array<Address>;
    /** canopy depth of merkle tree, reduces proofPath length if specified */
    canopyDepth?: number;
};
export type WithdrawCompressedAsyncInput<TAccountMaker extends string = string, TAccountOrderState extends string = string, TAccountOrderVault extends string = string, TAccountWhitelist extends string = string, TAccountSystem extends string = string, TAccountTlockProgram extends string = string, TAccountTreeAuthority extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountOrderNftReceipt extends string = string> = {
    maker: TransactionSigner<TAccountMaker>;
    orderState: Address<TAccountOrderState>;
    orderVault?: Address<TAccountOrderVault>;
    whitelist: Address<TAccountWhitelist>;
    system?: Address<TAccountSystem>;
    tlockProgram?: Address<TAccountTlockProgram>;
    treeAuthority?: Address<TAccountTreeAuthority>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    orderNftReceipt?: Address<TAccountOrderNftReceipt>;
    root: WithdrawCompressedInstructionDataArgs['root'];
    nonce?: WithdrawCompressedInstructionDataArgs['nonce'];
    index: WithdrawCompressedInstructionDataArgs['index'];
    metaArgs: WithdrawCompressedInstructionDataArgs['metaArgs'];
    creators?: WithdrawCompressedInstructionExtraArgs['creators'];
    proof?: WithdrawCompressedInstructionExtraArgs['proof'];
    canopyDepth?: WithdrawCompressedInstructionExtraArgs['canopyDepth'];
};
export declare function getWithdrawCompressedInstructionAsync<TAccountMaker extends string, TAccountOrderState extends string, TAccountOrderVault extends string, TAccountWhitelist extends string, TAccountSystem extends string, TAccountTlockProgram extends string, TAccountTreeAuthority extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountBubblegumProgram extends string, TAccountOrderNftReceipt extends string>(input: WithdrawCompressedAsyncInput<TAccountMaker, TAccountOrderState, TAccountOrderVault, TAccountWhitelist, TAccountSystem, TAccountTlockProgram, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountBubblegumProgram, TAccountOrderNftReceipt>): Promise<WithdrawCompressedInstruction<typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountMaker, TAccountOrderState, TAccountOrderVault, TAccountWhitelist, TAccountSystem, TAccountTlockProgram, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountBubblegumProgram, TAccountOrderNftReceipt>>;
export type WithdrawCompressedInput<TAccountMaker extends string = string, TAccountOrderState extends string = string, TAccountOrderVault extends string = string, TAccountWhitelist extends string = string, TAccountSystem extends string = string, TAccountTlockProgram extends string = string, TAccountTreeAuthority extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountOrderNftReceipt extends string = string> = {
    maker: TransactionSigner<TAccountMaker>;
    orderState: Address<TAccountOrderState>;
    orderVault: Address<TAccountOrderVault>;
    whitelist: Address<TAccountWhitelist>;
    system?: Address<TAccountSystem>;
    tlockProgram?: Address<TAccountTlockProgram>;
    treeAuthority: Address<TAccountTreeAuthority>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    orderNftReceipt: Address<TAccountOrderNftReceipt>;
    root: WithdrawCompressedInstructionDataArgs['root'];
    nonce?: WithdrawCompressedInstructionDataArgs['nonce'];
    index: WithdrawCompressedInstructionDataArgs['index'];
    metaArgs: WithdrawCompressedInstructionDataArgs['metaArgs'];
    creators?: WithdrawCompressedInstructionExtraArgs['creators'];
    proof?: WithdrawCompressedInstructionExtraArgs['proof'];
    canopyDepth?: WithdrawCompressedInstructionExtraArgs['canopyDepth'];
};
export declare function getWithdrawCompressedInstruction<TAccountMaker extends string, TAccountOrderState extends string, TAccountOrderVault extends string, TAccountWhitelist extends string, TAccountSystem extends string, TAccountTlockProgram extends string, TAccountTreeAuthority extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountBubblegumProgram extends string, TAccountOrderNftReceipt extends string>(input: WithdrawCompressedInput<TAccountMaker, TAccountOrderState, TAccountOrderVault, TAccountWhitelist, TAccountSystem, TAccountTlockProgram, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountBubblegumProgram, TAccountOrderNftReceipt>): WithdrawCompressedInstruction<typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountMaker, TAccountOrderState, TAccountOrderVault, TAccountWhitelist, TAccountSystem, TAccountTlockProgram, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountBubblegumProgram, TAccountOrderNftReceipt>;
export type ParsedWithdrawCompressedInstruction<TProgram extends string = typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        maker: TAccountMetas[0];
        orderState: TAccountMetas[1];
        orderVault: TAccountMetas[2];
        whitelist: TAccountMetas[3];
        system: TAccountMetas[4];
        tlockProgram: TAccountMetas[5];
        treeAuthority: TAccountMetas[6];
        merkleTree: TAccountMetas[7];
        logWrapper: TAccountMetas[8];
        compressionProgram: TAccountMetas[9];
        bubblegumProgram: TAccountMetas[10];
        orderNftReceipt: TAccountMetas[11];
    };
    data: WithdrawCompressedInstructionData;
};
export declare function parseWithdrawCompressedInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedWithdrawCompressedInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=withdrawCompressed.d.ts.map