import { ResolvedAccount } from '../generated/shared';
import { Address, IAccountMeta, ProgramDerivedAddress } from '@solana/web3.js';
type ArgsWithOptionalCreatorsField = {
    creators?: (readonly [Address, number])[];
    [key: string]: unknown;
};
type ArgsWithIndexField = {
    index?: number | bigint;
    [key: string]: unknown;
};
type ArgsWithOptionalProofAndCanopyDepth = {
    proof?: Address[] | undefined;
    canopyDepth?: number | undefined;
    [key: string]: unknown;
};
type ArgsAny = {
    [key: string]: unknown;
};
export declare const resolveOrderIdOnUpsert: (_: ArgsAny) => Uint8Array;
export declare const resolveCreatorPath: ({ args, }: {
    programAddress: Address;
    accounts: Record<string, ResolvedAccount>;
    args: ArgsWithOptionalCreatorsField;
}) => IAccountMeta[];
export declare const resolveProofPath: ({ args, }: {
    programAddress: Address;
    accounts: Record<string, ResolvedAccount>;
    args: ArgsWithOptionalProofAndCanopyDepth;
}) => IAccountMeta[];
export declare const resolveFeeVaultPdaFromOrderState: ({ accounts, }: {
    accounts: Record<string, ResolvedAccount>;
}) => Promise<Partial<{
    value: ProgramDerivedAddress | null;
}>>;
export declare const resolveFeeVaultPdaFromListState: ({ accounts, }: {
    accounts: Record<string, ResolvedAccount>;
}) => Promise<Partial<{
    value: ProgramDerivedAddress | null;
}>>;
export declare const resolveFeeVaultPdaFromPool: ({ accounts, }: {
    accounts: Record<string, ResolvedAccount>;
}) => Promise<Partial<{
    value: ProgramDerivedAddress | null;
}>>;
export declare const resolveOrderDepositReceiptCompressed: ({ accounts, args, }: {
    accounts: Record<string, ResolvedAccount>;
    args: ArgsWithIndexField;
}) => Promise<Partial<{
    value: ProgramDerivedAddress | null;
}>>;
export {};
//# sourceMappingURL=resolvers.d.ts.map